datablock PlayerData(PlayerFrozen : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	thirdpersononly = 1;
	jumpForce = 0;
	jumpSound = "";
	
	runForce = 0;
	maxBackwardspeed = 0;
	maxForwardSpeed = 0;
	maxSideSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxSideCrouchSpeed = 0;
	uiName = "";
};
if($Pref::SwolTrap_MaxTraps $= "")
	$Pref::SwolTrap_MaxTraps = 5;
if($Pref::SwolTrap_LockToGrid $= "")
	$Pref::SwolTrap_LockToGrid = 0;
if($Pref::SwolTrap_CoolDownReset $= "")
	$Pref::SwolTrap_CoolDownReset = 1;
function iniSwol_TrapSet()
{
	if(isObject(Swol_TrapSet))
	{
		Swol_TrapSet.removeAllTraps();
		Swol_TrapSet.delete();
	}
	$Swol_TrapSet = new scriptObject(Swol_TrapSet);
	$Swol_TrapSet.ini();
}
function Swol_TrapSet::ini(%set)
{
	%set.set = new simSet();
	%set.defaultFunc["Create"] = "trapCreate_Default";
	%set.defaultFunc["Remove"] = "trapRemove_Default";
	%set.defaultFunc["Trigger"] = "trapTrigger_Default";
	%set.defaultFunc["Break"] = "trapBreak_Default";
	%set.defaultFunc["Dmg"] = "trapDmg_Default";
	
	%set.lockToGrid = $Pref::SwolTrap_LockToGrid;
	%set.maxTrapsPerPlayer = $Pref::SwolTrap_MaxTraps;
	%set.coolDownReset = $Pref::SwolTrap_CoolDownReset;
	%set.path = "Add-ons/Weapon_Package_STraps";
	%pattern = "./traps/*.cs";
	%file = findFirstFile(%pattern);
	while(%file !$= "")
	{
		exec(%file);
		%file = findNextFile(%pattern);
	}
}
function Swol_TrapSet::getSet(%set){return %set.set;}
function Swol_TrapSet::addSet(%set,%obj){%set.getSet().add(%obj);}
function Swol_TrapSet::getActiveTrapCnt(%set,%cl)
{
	%num = 0;
	%cnt = %set.getSet().getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%o = %set.getSet().getObject(%i);
		if(%o.owner != %cl)
			continue;
		if(%o.activated)
			continue;
		%num++;
	}
	return %num;
}
function Swol_TrapSet::breakOldestActiveTrap(%set,%cl,%ext)
{
	%time = getSimTime();
	%obj = 0;
	%cnt = %set.getSet().getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%o = %set.getSet().getObject(%i);
		if(%o.owner != %cl)
			continue;
		if(%o.activated)
			continue;
		if(%o.createTime < %time)
		{
			%time = %o.createTime;
			%obj = %o;
		}
	}
	if(%ext $= "")
		%ext = "Break";
	if(isObject(%obj))
		%set.call(%set.defaultFunc["Dmg"],%obj,999999,%ext);
}
function serverCmdClearAllTraps(%cl)
{
	if(!%cl.isSuperAdmin)
		return;
	if(getSimTime()-%cl.lastTrapClear < 5000)
		return;
	%cl.lastTrapClear = getSimTime();
	if(!isObject(%set = Swol_TrapSet))
		return;
	%amt = %set.removeAllTraps();
	if(%amt != 0)
		messageAll('MsgClearBricks',"\c3" @ %cl.getPlayerName() @ " \c0cleared all traps \c3(" @ %amt @ ")");
}
function serverCmdClearTraps(%cl,%a,%b,%c,%d,%e,%f,%g,%h,%i,%j,%k)
{
	if(!%cl.isSuperAdmin)
		return;
	if(getSimTime()-%cl.lastTrapClear < 5000)
		return;
	%name = trim(%a SPC %b SPC %c SPC %d SPC %e SPC %f SPC %g SPC %h SPC %i SPC %j SPC %k);
	if(%name $= "")
		return messageClient(%cl,'',"\c0Invalid paramaters \c3/clearTraps <name> \c0or instead use \c3/clearAllTraps");
	%vic = findclientbyname(%name);
	if(!isObject(%vic))
		return messageClient(%cl,'',"\c0Could not find client \"" @ %name @ "\"");
	if(!isObject(%set = Swol_TrapSet))
		return;
	%cl.lastTrapClear = getSimTime();
	%amt = %set.removeOwnedTraps(%vic);
	%name = %vic.getPlayerName();
	if(getSubStr(%name,strLen(%name),1) $= "s")
		%name = %name @ "'";
	else
		%name = %name @ "'s";
	if(%amt != 0)
		messageAll('MsgClearBricks',"\c3" @ %cl.getPlayerName() @ " \c0cleared \c3" @ %name @ " \c0traps \c3(" @ %amt @ ")");
}
function Swol_TrapSet::removeOwnedTraps(%set,%cl)
{
	%i = %set.getSet().getCount();
	%cnt = 0;
	while(%i-->=0)
	{
		%o = %set.getSet().getObject(%i);
		if(%o.owner != %cl)
			continue;
		%cnt++;
		if((%func = %o.getDatablock().useCmd["Remove"]) !$= "" && isFunction(%set,%func))
		{
			%set.call(%func,%o);
		}
		else
		{
			%set.call(%set.defaultFunc["Remove"],%o);
		}
	}
	return %cnt;
}
function Swol_TrapSet::removeAllTraps(%set)
{
	%i = %set.getSet().getCount();
	%cnt = %i;
	while(%i-->=0)
	{
		%o = %set.getSet().getObject(%i);
		if((%func = %o.getDatablock().useCmd["Remove"]) !$= "" && isFunction(%set,%func))
		{
			%set.call(%func,%o);
		}
		else
		{
			%set.call(%set.defaultFunc["Remove"],%o);
		}
	}
	return %cnt;
}
function Swol_TrapSet::createTrap(%set,%trap,%trans)
{
	if((%func = %trap.useCmd["Create"]) !$= "" && isFunction(%set,%func))
	{
		return %set.call(%func,%trans,%trap);
	}
	else
	{
		return %set.call(%set.defaultFunc["Create"],%trans,%trap);
	}
}
function Swol_TrapSet::trapCreate_Default(%set,%trans,%db)
{
	%pos = posFromTransform(%trans);
	%rot = rotFromTransform(%trans);
	%trap = new StaticShape()
	{
		position = vectorAdd(%pos,%db.offset);
		rotation = %rot;
		scale = %db.scale;
		datablock = %db;
	};
	%trap.setTransform(%trap.getPosition() SPC %rot);
	if(%db.rootAnim !$= "")
		%trap.playThread(1,%db.rootAnim);
	%trap.isTrap = true;
	%trap.activated = false;
	%trap.set = %set;
	%trap.createTime = getSimTime();
	%trigger = %trap.trigger = new Trigger()
	{
		datablock = %db.triggerDb;
		scale = %db.triggerScale;
		polyhedron = "-0.5 -0.5 -0.5 1 0 0 0 1 0 0 0 1";
		position = %pos;
		rotation = %rot;
	};
	%trigger.trap = %trap;
	%set.addSet(%trap);
	return %trap;
}
function Swol_TrapSet::trapRemove_Default(%set,%trap)
{
	if(isObject(%trig = %trap.trigger))
		%trig.delete();
	%trap.delete();
}
function Swol_TrapSet::trapTrigger_Default(%set,%trap,%victim)
{
	%db = %trap.getDatablock();
	if(isObject(%db.triggerExplosion))
	{
		%p = new Projectile()
		{
			datablock = %db.triggerExplosion;
			initialPosition = %trap.getPosition();
			scale = "1 1 1";
		};
		%p.explode();
	}
	if(%db.triggerAnim !$= "")
		%trap.playThread(1,%db.triggerAnim);
		
	%trap.activated = true;
}
function Swol_TrapSet::trapBreak_Default(%set,%trap)
{
	%db = %trap.getDatablock();
	if(isObject(%db.breakExplosion))
	{
		%p = new Projectile()
		{
			datablock = %db.breakExplosion;
			initialPosition = %trap.getPosition();
			initialVelocity = "0 0 1";
			scale = "1 1 1";
			sourceSlot = 0;
		};
		if(isObject(%trap.owner))
		{
			%trap.client = %p.sourceClient = %p.client = %trap.owner;
			%p.sourceObject = %trap;
		}
		%p.schedule(1,explode);
	}
	if((%func = %db.useCmd["Remove"]) !$= "" && isFunction(%set,%func))
	{
		%set.call(%func,%trap);
	}
	else
	{
		%set.call(%set.defaultFunc["Remove"],%trap);
	}
}
function Swol_TrapSet::trapDmg_Default(%set,%trap,%dmg,%breakM)
{
	%db = %trap.getDatablock();
	%trap.dmg += %dmg;
	if(%trap.dmg >= %db.trapHp)
	{
		%trap.activated = true;
		%set = %trap.set;

		if((%func = %db.useCmd[%breakM]) !$= "" && isFunction(%set,%func))
		{
			%set.call(%func,%trap);
		}
		else if((%func = %db.useCmd["Break"]) !$= "" && isFunction(%set,%func))
		{
			%set.call(%func,%trap);
		}
		else
		{
			%set.call(%set.defaultFunc["Break"],%trap);
		}
	}
}
function player::swol_trapPlaceStart(%pl,%db)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	if(isObject(%pl.client) && isObject(%pl.client.tempTrap))
		%pl.client.tempTrap.delete();
	if(getSimTime()-%pl.trap_coolDown[%db] < %db.cooldown)
	{
		%m = %pl.getMountedImage(0);
		if(isObject(%m))
			%pl.swol_trapCooldownWaitStart(%db,%m);
		return;
	}
	%a = %db;
	if(isObject(%db.ghost))
		%db = %db.ghost;
	%trans = %pl.getTransform();
	%pos = posFromTransform(%trans);
	%rot = rotFromTransform(%trans);
	%rad = getWord(%rot,3);
	%deg = mRadToDeg(%rad);
	%trap = new StaticShape()
	{
		position = "0 0 0";
		rotation = "0 0 1 0";
		scale = %db.scale;
		datablock = %db;
	};
	if(isObject(%pl.client) && !Swol_TrapSet.disableSoleScope && isFunction("NetObject",setNetFlag)) //heh
	{
		%trap.setNetFlag(6,1);
		%trap.scopeToClient(%pl.client);
	}
	%trap.placeDb = %a;
	%trap.isTempTrap = true;
	if(%db.rootAnim !$= "")
		%trap.playThread(1,%db.rootAnim);
	%trap.setNodeColor("ALL","0.5 0 0 1");
	%pl.tempTrap = %trap;
	%pl.client.tempTrap = %trap;
	%pl.swol_trapLoop("");
}
function player::swol_trapLoop(%pl,%trapPos)
{
	%pscale = getWord(%pl.getScale(),2);
	%tickPeriod = 1;
	cancel(%pl.trapLoop);
	if(!isObject(%trap = %pl.tempTrap))
		return;
	if(isObject(%im = %pl.getMountedImage(0)))
	{
		if((!%im.isTrap || %im.trapDb !$= %trap.placeDb.getName()))
		{
			%pl.swol_trapPlaceStop();
			return;
		}
	}
	else
	{
		%pl.swol_trapPlaceStop();
		return;
	}
	%db = %trap.placeDb;
	%pass = false;
	%trans = %pl.getTransform();
	%posI = posFromTransform(%trans);
	%rotI = rotFromTransform(%trans);
	%eulerRot = (getWord(axisToEuler(%rotI),2)+90)*$PI/180;
	
	%eye = vectorScale(%pl.getEyeVector(),10);
	%ppos = %pl.getEyePoint();
	%mask = ($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType);
	%hr = containerRaycast(%ppos,vectorAdd(%ppos,%eye),%mask,%obj);
	%dist = 4;
	if(vectorDist(getWords(%pl.getPosition(),0,1) SPC 0,getWords(%hr,1,2) SPC 0) < %dist)
		%dist = vectorDist(getWords(%pl.getPosition(),0,1) SPC 0,getWords(%hr,1,2) SPC 0);
	if(%db.groundSafety $= "")
		%groundSafety = 0.5;
	else
		%groundSafety = 0.1;
		
	if(getWord(%pl.getPosition(),2)-getWord(%hr,3) < 0.2)
		if(%dist < %groundSafety)
			%dist = %groundSafety;
	%pos = mCos(%eulerRot)*%dist SPC mSin(%eulerRot)*%dist SPC 0.2;
	%pos = vectorAdd(%pos,%posI);
	%r = containerRayCast(vectorAdd(%pos,"0 0 2"),vectorAdd(%pos,"0 0 -5"),%mask,%trap);
	if(!isObject(getWord(%r,0)))
		%pass = false;
	else
		%pass = true;
	if(%pass)
	{
		
		%hitPos = getWord(%hr,3);
		%topHit = getWord(%r,3);
		%hitPos = mClampF(%hitPos,0,%topHit);
		if(Swol_TrapSet.lockToGrid != 0)
			%pos = swol_lockGridPosition(getWords(%pos,0,1) SPC %hitPos,Swol_TrapSet.lockToGrid+1);
		else
			%pos = getWords(%pos,0,1) SPC %hitPos;
	}
	else
		%topHit = "";
	%px = getWord(%trapPos,0);
	%py = getWord(%trapPos,1);
	%pz = getWord(%trapPos,2);
	%mx = getWord(%pos,0);
	%my = getWord(%pos,1);
	%tx = %mx - %px;
	%ty = %mY - %py;
	%ang = mAtan(%ty,%tx);
	%dist = vectorDist(%mx SPC %my SPC 0,%px SPC %py SPC 0);
	%factor = mClampF(%dist/(20*%tickPeriod),0.15*%tickPeriod,1*%tickPeriod);
	%isToAim = false;
	%distToAim = %dist;
	if(%trapPos $= "")
		%trapPos = %pos;
	else
	{
		if(%dist < 0.01)
		{
			%trapPos = %pos;
			%isToAim = true;
		}
		else
		{
			%trapPos = %px+((%dist*%factor)*mCos(%ang)) SPC %py+((%dist*%factor)*mSin(%ang)) SPC getWord(%pos,2);
		}
	}
	%pos = %trapPos;
	%max = 7;
	if(%pass)
	{
		%scale = %db.checkScale;
		%passMax = %max*%max;
		%passAcceptable = 0.9;
		%passCnt = 0;
		%w = getWord(%scale,0);
		%h = getWord(%scale,1);
		for(%y=0;%y<%max;%y++)
		{
			for(%x=0;%x<%max;%x++)
			{
				%tmp = %pos;
				%tmp = vectorAdd(%tmp,(%x-(%max/2))*(%w*(1/%max)) SPC (%y-(%max/2))*(%h*(1/%max)) SPC 0);
				%r = containerRayCast(vectorAdd(%tmp,"0 0 0.4"),vectorAdd(%tmp,"0 0 -0.2"),($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType),%trap);
				if(isObject(%r))
					%passCnt++;
			}
		}
	}
	if(%passCnt < %passMax*%passAcceptable)
		%pass = false;
	%trap.setTransform(%pos SPC %rotI);
	%r = containerRaycast(%ppos,vectorAdd(%trap.getPosition(),"0 0 0.2"),%mask,%trap);
	if(isObject(%r))
		%pass = false;
	if(%pass)
	{
		initContainerBoxSearch(vectorAdd(%pos,"0 0 0.12"),%db.checkScale,$TypeMasks::FxBrickObjectType | $TypeMasks::staticShapeObjectType);
		while(%obj = containerSearchNext())
		{
			if(%obj == %trap)
				continue;
			if(%obj.isTempTrap)
				continue;
			%pass = false;

			break;
		}
	}
	if(!%pass)
	{
		if(%topHit !$= "")
		{
			%pos = getWords(%pos,0,1) SPC %topHit;
			%tmpPass = true;
		}
		else
		{
			%pos = getWords(%pos,0,1) SPC getWord(%pl.getPosition(),2);
			%tmpPass = false;
		}
	}
	else
		%tmpPass = false;
	if(%tmpPass)
	{
		%scale = %db.checkScale;
		%passMax = %max*%max;
		%passAcceptable = 0.9;
		%passCnt = 0;
		%w = getWord(%scale,0);
		%h = getWord(%scale,1);
		for(%y=0;%y<%max;%y++)
		{
			for(%x=0;%x<%max;%x++)
			{
				%tmp = %pos;
				%tmp = vectorAdd(%tmp,(%x-(%max/2))*(%w*(1/%max)) SPC (%y-(%max/2))*(%h*(1/%max)) SPC 0);
				%r = containerRayCast(vectorAdd(%tmp,"0 0 0.4"),vectorAdd(%tmp,"0 0 -0.2"),($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType),%trap);
				if(isObject(%r))
					%passCnt++;
			}
		}
		if(%passCnt < %passMax*%passAcceptable)
			%tmpPass = false;
	}
	%trap.setTransform(%pos SPC %rotI);
	if(%tmpPass)
	{
		%r = containerRaycast(%ppos,%trap.getPosition(),%mask,%trap);
		if(isObject(%r))
			%tmpPass = false;
	}
	if(%tmpPass)
	{
		initContainerBoxSearch(vectorAdd(%pos,"0 0 0.12"),%db.checkScale,$TypeMasks::FxBrickObjectType | $TypeMasks::staticShapeObjectType);
		while(%obj = containerSearchNext())
		{
			if(%obj == %trap)
				continue;
			if(%obj.isTempTrap)
				continue;
			%tmpPass = false;
			break;
		}
	}
	if(!%tmpPass)
	{
		if(%topHit $= "")
			%hitPos = getWord(%pl.getPosition(),2);
		%trap.setTransform(getWords(%pos,0,1) SPC %hitPos SPC %rotI);
	}
	else
		%pass = true;
	if(%pass)
	{
		%trap.setNodeColor("ALL","0.4 1 0.4 1");
		%trap.pass = true;
	}
	else
	{
		%trap.setNodeColor("ALL","1 0.4 0.4 1");
		%trap.pass = false;
	}
	if(isObject(%cl = %pl.client))
	{
		bottomPrint(%cl,"<tab:100>\c6Trap\t<color:ffffaa>" @ %db.uiName @ "<just:right>" @ %cntStr @ " <just:left>" @ (!%pass ? "<br><tab:100><color:ffbbbb>Left Click\t<color:ff5555>Invalid Placement" : "<br><tab:100>\c6Left Click\t<color:aaffaa>Place Trap") @ "",1);
	}
	%pl.trapLoop = %pl.schedule(16*%tickPeriod,swol_trapLoop,%trapPos);
}
function vectorGetMin(%pos)
{
	%lowest = "";
	%cnt = getWordCount(%pos);
	for(%i=0;%i<%cnt;%i++)
	{
		%p = getWord(%pos,%i);
		if(%lowest $= "")
			%lowest = %p;
		else if(%p < %lowest)
			%lowest = %p;
	}
	return %lowest;
}
function swol_lockGridPosition(%pos,%factor)
{
	if(%factor $= "")
		%factor = 2;
	%pos = vectorScale(%pos,%factor);
	%x = mFloor(getWord(%pos,0))/%factor;
	%y = mFloor(getWord(%pos,1))/%factor;
	%z = getWord(%pos,2);
	%pos = %x SPC %y SPC %z;
}
function player::swol_trapPlace(%pl)
{
	if(!isObject(%trap = %pl.tempTrap))
		return;
	if(!%trap.pass)
		return;
	%pl.playThread(1,root);
	%trans = %trap.getTransform();
	%nTrap = Swol_TrapSet.createTrap(%trap.placeDb,%trans);
	%nTrap.owner = %pl.client;
	%trap.delete();
	%pl.trapItem = %pl.currTool;
	%pl.trapImage = %pl.getMountedImage(0);
	%pl.unMountImage(0);
	if(isObject(%cl = %pl.client))
	{
		bottomPrint(%cl,"<color:ffffaa>" @ %nTrap.getDatablock().uiName @ " \c6placed!",2);
		if(Swol_TrapSet.getActiveTrapCnt(%cl) > Swol_TrapSet.maxTrapsPerPlayer)
			Swol_TrapSet.breakOldestActiveTrap(%cl);
	}
	if(Swol_TrapSet.coolDownReset)
	{
		%pl.trap_coolDown[%pl.trapImage.trapDb] = getSimTime();
		%pl.trapResetSched = %pl.schedule(500,swol_trapPlaceReset);
	}
	else if(%pl.trapImage.singleUse)
	{
		%pl.tool[%pl.trapItem] = 0;
		%pl.weaponCount--;
		%pl.unMountImage(0);
		if(isObject(%cl))
			messageClient(%cl,'MsgItemPickup','',%pl.trapItem,0,1);
	}
	else
	{
		%pl.trapResetSched = %pl.schedule(500,swol_trapPlaceReset);
	}
}
function player::swol_trapPlaceReset(%pl)
{
	if(%pl.currTool != %pl.trapItem)
		return;
	%pl.mountImage(%pl.trapImage,0);
}
function player::swol_trapCooldownWaitStart(%pl,%db,%m)
{
	%slot = %pl.currTool;			
	%pl.swol_trapCooldownWait(%db,%db.cooldown,%pl.trap_coolDown[%db],%m,%slot);
}
function player::swol_trapCooldownWait(%pl,%db,%cd,%st,%im,%slot)
{
	cancel(%pl.trapCdWaitSched);
	%left = getSimTime()-%st;
	if(%pl.currTool != %slot)
		return;
	if(!isObject(%pl.tool[%slot]))
		return;
	if(!isObject(%pl.tool[%slot].image))
		return;
	if(%pl.tool[%slot].image.getId() != %im)
		return;	
	if(%left >= %cd)
	{
		%pl.mountImage(%im,0);
		%pl.swol_trapPlaceStart(%db);
		return;
	}
	%prcnt = %left/%cd;
	%max = 30;
	%fill = mFloor(%prcnt*%max);
	%col = rgbGradient(%prcnt,"1 0.6 0.6","0.6 1 0.6");
	%hex = rgbToHex(%col);
	%bars = "<font:Impact:14><color:" @ %hex @ ">";
	for(%i=0;%i<%fill;%i++)
		%bars = %bars @ "|";
	%bars = %bars @ "\c6";
	for(%i=0;%i<%max-%fill;%i++)
		%bars = %bars @ "|";
	if(isObject(%cl = %pl.client))
		bottomPrint(%cl,"<tab:100>\c6Trap\t<color:ffffaa>" @ %db.uiName @ "<br><tab:100>\c6Charging\t" @ %bars,1);
	%pl.trapCdWaitSched = %pl.schedule(50,swol_trapCooldownWait,%db,%cd,%st,%im,%slot);
}
function player::swol_trapPlaceStop(%pl)
{
	if(isObject(%pl.tempTrap))
		%pl.tempTrap.delete();
	if(isObject(%cl = %pl.client))
		bottomPrint(%cl,"",1);
}
if(!isObject(Swol_TrapSet))
	iniSwol_TrapSet();
package swol_traps
{
	function Observer::onTrigger(%db,%cam,%trig,%bool)
	{
		if(isObject(%cl = %cam.getControllingClient()))
			if(isObject(%pl = %cl.player))
				if(%pl.cameraTriggerDisabled)
					return;
		parent::onTrigger(%db,%cam,%trig,%bool);
	}
	function MinigameSO::addMember(%mini,%cl)
	{
		Swol_TrapSet.removeOwnedTraps(%cl);
		return parent::addMember(%mini,%cl);
	}
	function MinigameSO::removeMember(%mini,%cl)
	{
		Swol_TrapSet.removeOwnedTraps(%cl);
		return parent::removeMember(%mini,%cl);
	}
	function MinigameSO::reset(%mini,%cl)
	{
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%o = %mini.member[%i];
			Swol_TrapSet.removeOwnedTraps(%o);
		}
		return parent::reset(%mini,%cl);
	}
	function MinigameSO::endGame(%mini)
	{
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%o = %mini.member[%i];
			Swol_TrapSet.removeOwnedTraps(%o);
		}
		return parent::endGame(%mini);
	}
	function ProjectileData::impactImpulse(%db,%proj,%hit,%vec)
	{
		if(%hit.getType() & $TypeMasks::PlayerObjectType)
		{
			if(%hit.getDatablock().getName() $= PlayerFrozen)
				return;
		}
		return parent::impactImpulse(%db,%proj,%hit,%vec);
	}
	function ProjectileData::radiusImpulse(%db,%proj,%hit,%distanceFactor,%pos,%impulseAmt,%verticalAmt)
	{
		if(%hit.getType() & $TypeMasks::PlayerObjectType)
		{
			if(%hit.getDatablock().getName() $= PlayerFrozen)
				return;
		}
		return parent::radiusImpulse(%db,%proj,%hit,%distanceFactor,%pos,%impulseAmt,%verticalAmt);
	}
	function ProjectileData::onExplode(%db,%proj,%pos)
	{
		if((%radius = %db.explosion.damageRadius) <= 0.01)
			return parent::onExplode(%db,%proj,%pos);
		%mask = $TypeMasks::StaticShapeObjectType;
		initContainerRadiusSearch(%pos,%radius,%mask);
		while(%hit = containerSearchNext())
		{
			if(%hit.isTrap)
			{
				%res = swol_trapMinigameValid(%hit.owner,%proj.client);
				if(%res == 1 || (%res == -1 && %proj.client == %hit.owner))
				{
					%dbT = %hit.getDatablock();
					if(%hit.activated && !%dbT.bypassExplosionActivated)
						continue;
					if(%dbT.triggerWithProjectiles)
					{
						%set = %hit.set;
						%exp = %db.explosion;
						%dist = vectorDist(%pos,%hit.getPosition());
						%damageRadius = %exp.damageRadius;
						%damageDistFactor = 1-((%dist/%damageRadius)*(%dist/%damageRadius));
						%radiusDamage = %exp.radiusDamage * %proj.getScale();
						%set.call(%set.defaultFunc["Dmg"],%hit,mClampF(%radiusDamage*%damageDistFactor,0,9999),"ExpBreak");
					}
				}
			}
		}
		return parent::onExplode(%db,%proj,%pos);
	}
	function player::setVelocity(%pl,%vel)
	{
		if(%pl.getDatablock().getName() $= PlayerFrozen && !%pl.velOverride)
			return;
		return parent::setVelocity(%pl,%vel);
	}
	function gameConnection::onDeath(%cl,%killer,%killerPlayer,%dmgType,%loc,%a)
	{
		if(isObject(%trap = %cl.tempTrap))
			%trap.delete();
		return parent::onDeath(%cl,%killer,%killerPlayer,%dmgType,%loc,%a);
	}
	function gameConnection::onClientLeaveGame(%cl)
	{
		if(isObject(%trap = %cl.tempTrap))
			%trap.delete();
		Swol_TrapSet.removeOwnedTraps(%cl);
		return parent::onClientLeaveGame(%cl);
	}
	function gameConnection::instantRespawn(%cl,%clAgain)
	{
		if(isObject(%trap = %cl.tempTrap))
			%trap.delete();
		return parent::instantRespawn(%cl,%clAgain);
	}
	function Armor::onRemove(%db,%pl)
	{
		if(isObject(%trap = %pl.tempTrap))
			%trap.delete();
		return parent::onRemove(%db,%pl);
	}
	function Armor::onTrigger(%this,%pl,%trig,%bool)
	{
		%ret = parent::onTrigger(%this,%pl,%trig,%bool);
		if(isObject(%trap = %pl.tempTrap))
		{
			if(%bool)
			{
				if(%trig == 0)
				{
					if(%trap.pass)
					{
						%pl.swol_trapPlace();
						%pl.playThread(2,activate2);
					}
				}
			}
		}
		return %ret;
	}
	function projectileData::onCollision(%db,%proj,%hit,%a,%b,%c,%d)
	{
		%ret = parent::onCollision(%db,%proj,%hit,%a,%b,%c,%d);
		if(%hit.isTrap)
		{
			%res = swol_trapMinigameValid(%hit.owner,%proj.client);
			if(%res == 1)
			{
				if(%hit.activated)
					return %ret;
				%dbT = %hit.getDatablock();
				if(%dbT.triggerWithProjectiles)
				{
					%set = %hit.set;
					%set.call(%set.defaultFunc["Dmg"],%hit,%db.directDamage,"ProjBreak");
				}
			}
		}
		return %ret;
	}
};
activatePackage(swol_traps);
function swol_trapMinigameValid(%clA,%clB)
{
	if(%clA.getClassName() !$= "GameConnection" && %clA.getClassName() !$= "ScriptObject")
	{
		if(isObject(%clA.client))
			%clA = %clA.client;
		else if(%clA.getClassName() $= "AiPlayer")
		{
			if(isObject(%clA.spawnBrick))
			{
				if(!isObject(%clA.spawnBrick.getGroup()))
					return 0;
				if(isObject(%clA.spawnBrick.getGroup().client))
					%clA = %clA.spawnBrick.getGroup().client;
				else if(%clA.spawnBrick.getGroup().bl_id == 8888888)
					return 1;
			}
		}
	}
	if(%clB.getClassName() !$= "GameConnection")
	{
		if(isObject(%clB.client))
			%clB = %clB.client;
		else if(%clB.getClassName() $= "AiPlayer")
		{
			if(isObject(%clB.spawnBrick))
			{
				if(!isObject(%clB.spawnBrick.getGroup()))
					return 0;
				if(isObject(%clB.spawnBrick.getGroup().client))
					%clB = %clB.spawnBrick.getGroup().client;
				else if(%clB.spawnBrick.getGroup().bl_id == 8888888)
					return 1;
			}
		}
	}
	%mA = %clA.minigame;
	%mB = %clB.minigame;
	if(!isObject(%mA) || !isObject(%mB))
	{
		if(%clA == %clB)
			return 1;
		return 0;
	}
	if(%mA == %mB)
	{
		%m = %mA;
		if(%m.class $= "Slayer_MinigameSO")
		{
			%tA = %clA.getTeam();
			%tB = %clB.getTeam();
			if(%tA == %tB && %tA != 0)
				return 0;
			return 1;
		}
		else if((Swol_TrapSet.legacyTDM || (Swol_TrapSet.legacyTDM=(isFunction(gameModeAttribute) && isFunction(gameModeTitleToID)))) && (%id = gameModeTitleToID(%m.gamemode)) != -1 && gameModeAttribute(%id,"UsesTeams"))
		{
			//Does anyone even use spaceguy's tdm anymore?
			if(%clA.tdmTeam != %clB.tdmTeam)
				return 1;
			return 0;
		}
		else
		{
			return 1;
		}
	}
}
function player::swolSupp_pullToLocation(%pl,%pos,%factor,%safety,%maxSafety)
{
	//Delicious movement
	if(%safety > %maxSafety)
	{
		%pl.velOverride = true;
		%pl.setVelocity("0 0 0");
		%pl.velOverride = false;
		return;
	}
	cancel(%pl.pullSched);
	%px = getWord(%pl.getPosition(),0);
	%py = getWord(%pl.getPosition(),1);
	%pz = getWord(%pl.getPosition(),2);
	%mx = getWord(%pos,0);
	%my = getWord(%pos,1);
	%tx = %mx - %px;
	%ty = %mY - %py;
	%ang = mAtan(%ty,%tx);
	%dist = vectorDist(%mx SPC %my SPC 0,%px SPC %py SPC 0);
	if(%dist < 0.01)
	{
		%pl.velOverride = true;
		%pl.setVelocity("0 0 0");
		%pl.velOverride = false;
		return;
	}
	%pl.velOverride = true;
	%pl.setVelocity(((%dist*%factor)*mCos(%ang)) SPC ((%dist*%factor)*mSin(%ang)) SPC 0);
	%pl.velOverride = false;
	%pl.pullSched = %pl.schedule(32,swolSupp_pullToLocation,%pos,%factor,%safety++,%maxSafety);
}
function player::swolSupp_SaveMoveSpeed(%pl)
{
	%pl.swol_tmpForwardSpeed = %pl.getMaxForwardSpeed();
	%pl.swol_tmpBackwardSpeed = %pl.getMaxBackwardSpeed();
	%pl.swol_tmpSideSpeed = %pl.getMaxSideSpeed();

	%pl.swol_tmpForwardCrouchSpeed = %pl.getMaxCrouchForwardSpeed();
	%pl.swol_tmpBackwardCrouchSpeed = %pl.getMaxCrouchBackwardSpeed();
	%pl.swol_tmpSideCrouchSpeed = %pl.getMaxCrouchSideSpeed();
}
function player::swolSupp_ResetMoveSpeed(%pl)
{
	%pl.setMaxForwardSpeed(%pl.swol_tmpForwardSpeed);
	%pl.setMaxBackwardSpeed(%pl.swol_tmpBackwardSpeed);
	%pl.setMaxSideSpeed(%pl.swol_tmpSideSpeed);
	%pl.setMaxCrouchForwardSpeed(%pl.swol_tmpForwardCrouchSpeed);
	%pl.setMaxCrouchSideSpeed(%pl.swol_tmpBackwardCrouchSpeed);
	%pl.setMaxCrouchBackwardSpeed(%pl.swol_tmpSideCrouchSpeed);
}
function player::swolSupp_NullMoveSpeed(%pl)
{
	%pl.setMaxForwardSpeed(0);
	%pl.setMaxBackwardSpeed(0);
	%pl.setMaxSideSpeed(0);
	%pl.setMaxCrouchForwardSpeed(0);
	%pl.setMaxCrouchSideSpeed(0);
	%pl.setMaxCrouchBackwardSpeed(0);
}
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}
function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
function rgbToHex( %rgb )
{
	%r = _compToHex( 255 * getWord( %rgb, 0 ) );
	%g = _compToHex( 255 * getWord( %rgb, 1 ) );
	%b = _compToHex( 255 * getWord( %rgb, 2 ) );

	return %r @ %g @ %b;
}
function _compToHex( %comp )
{
	%left = mFloor( %comp / 16 );
	%comp = mFloor( %comp - %left * 16 );

	%left = getSubStr( "0123456789ABCDEF", %left, 1 );
	%comp = getSubStr( "0123456789ABCDEF", %comp, 1 );

	return %left @ %comp;
}
function rgbGradient(%step, %c1, %c2)
{
	%r1 = getWord(%c1, 0);
	%g1 = getWord(%c1, 1);
	%b1 = getWord(%c1, 2);

	%r2 = getWord(%c2, 0);
	%g2 = getWord(%c2, 1);
	%b2 = getWord(%c2, 2);

	%r3 = %r1 + %step * (%r2 - %r1);
	%g3 = %g1 + %step * (%g2 - %g1);
	%b3 = %b1 + %step * (%b2 - %b1);

	return %r3 SPC %g3 SPC %b3;
}