AddDamageType("BearTrap",'%1 stepped into their own bear trap.','%2 crushed %1 in a bear trap',0.2,1);
datablock StaticShapeData(Trap_BearTrap)
{
	shapeFile = Swol_TrapSet.path @ "/model/beartrap.dts";
	trigger = bearTrapTrigger;
	offset = "0 0 -0.05";
	ghost = Trap_BearTrapGhost;
	scale = "1 1 1";
	triggerAnim = "snap";
	triggerExplosion = bearTrapSnapExplosionProjectile;
	placeExplosion = bearTrapSnapExplosionProjectile;
	breakExplosion = bearTrapExplosionProjectile;
	rootAnim = "root";
	triggerDb = Trap_BearTrapTrigger;
	triggerScale = "2 2 0.4";
	checkScale = "1.9 1.9 0.2";
	triggerWithProjectiles = true;
	trapDmg = 35;
	trapHp = 20;
	holdTime = 2500;
	groundSafety = 2.5;
	bypassExplosionActivated = true;
	cooldown = 15000;
	
	useCmd["Create"] = "trapCreate_BearTrap";
	useCmd["Remove"] = "";
	useCmd["Break"] = "trapBreak_BearTrap";
	useCmd["ProjBreak"] = "trapProjBreak_BearTrap";
	useCmd["ExpBreak"] = "";
	useCmd["Trigger"] = "trapTrigger_BearTrap";
	
	trapName = "BearTrap";
	uiName = "Bear Trap";
};
datablock StaticShapeData(Trap_BearTrapGhost)
{
	shapeFile = Swol_TrapSet.path @ "/model/beartrap_ghost.dts";
};
datablock TriggerData(Trap_BearTrapTrigger)
{
   tickPeriodMS = 50;
};
datablock DebrisData(bearTrapFragDebris)
{
	shapeFile 			= Swol_TrapSet.path @ "/model/debris_frag.dts";
	lifetime 			= 2.8;
	spinSpeed			= 1200.0;
	minSpinSpeed 		= -3600.0;
	maxSpinSpeed 		= 3600.0;
	elasticity 			= 0.5;
	friction 			= 0.2;
	numBounces 			= 3;
	staticOnMaxBounce 	= true;
	snapOnMaxBounce 	= false;
	fade 				= true;
	gravModifier 		= 4;
};
datablock DebrisData(bearTrapJawDebris : bearTrapFragDebris)
{
	shapeFile 			= Swol_TrapSet.path @ "/model/debris_jaw.dts";
	spinSpeed			= 300.0;
	minSpinSpeed 		= -1200.0;
	maxSpinSpeed 		= 1200.0;
};
datablock DebrisData(bearTrapToothDebris : bearTrapFragDebris)
{
	shapeFile 			= Swol_TrapSet.path @ "/model/debris_tooth.dts";
};
datablock DebrisData(bearTrapBaseDebris : bearTrapJawDebris)
{
	shapeFile 			= Swol_TrapSet.path @ "/model/debris_base.dts";
};
datablock ParticleData(bearTrapExplosionParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.6 0.6 0.6 0.3";
	colors[1]			= "0.6 0.6 0.6 0.0";
	sizes[0]			= 1.25;
	sizes[1]			= 2.25;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(bearTrapExplosionEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 1.0;
	ejectionOffset  	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= bearTrapExplosionParticle;
};
datablock ExplosionData(bearTrapSubExplosion1)
{
	debris 					= bearTrapJawDebris;
	debrisNum 				= 2;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
};
datablock ExplosionData(bearTrapSubExplosion2 : bearTrapSubExplosion1)
{
	debris 					= bearTrapBaseDebris;
	debrisNum 				= 1;
};
datablock ExplosionData(bearTrapSubExplosion3 : bearTrapSubExplosion1)
{
	debris 					= bearTrapToothDebris;
	debrisNum 				= 8;
	debrisNumVariance 		= 2;
};
datablock ExplosionData(bearTrapSubExplosion4 : bearTrapSubExplosion1)
{
	debris 					= bearTrapFragDebris;
	debrisNum 				= 8;
	debrisNumVariance 		= 2;
};
datablock ExplosionData(bearTrapExplosion)
{
	debris 					= bearTrapFragDebris;
	debrisNum 				= 12;
	debrisNumVariance 		= 8;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
	lifeTimeMS 				= 150;
	subExplosion[0] 		= bearTrapSubExplosion1;
	subExplosion[1] 		= bearTrapSubExplosion2;
	subExplosion[2] 		= bearTrapSubExplosion3;
	subExplosion[3] 		= bearTrapSubExplosion4;
	explosionShape 			= "";
	particleEmitter 		= bearTrapExplosionEmitter;
	particleDensity 		= 10;
	particleRadius 			= 0.2;
	faceViewer     			= true;
	explosionScale 			= "1 1 1";
	shakeCamera 			= true;
	camShakeFreq 			= "10.0 11.0 10.0";
	camShakeAmp 			= "3.0 4.0 3.0";
	camShakeDuration 		= 0.3;
	camShakeRadius 			= 20.0;
};
datablock ProjectileData(bearTrapExplosionProjectile)
{
	explosion = bearTrapExplosion;
};
datablock ExplosionData(bearTrapSnapExplosion)
{
	debris 					= bearTrapFragDebris;
	debrisNum 				= 12;
	debrisNumVariance 		= 8;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
	particleEmitter 		= bearTrapExplosionEmitter;
	particleDensity 		= 5;
	particleRadius 			= 0.2;
	lifeTimeMS 				= 150;
	faceViewer     			= true;
	explosionScale 			= "1 1 1";
	shakeCamera 			= true;
	camShakeFreq 			= "5.0 6.0 5.0";
	camShakeAmp 			= "1.0 2.0 1.0";
	camShakeDuration 		= 0.3;
	camShakeRadius 			= 20.0;
};
datablock ProjectileData(bearTrapSnapExplosionProjectile)
{
	explosion = bearTrapSnapExplosion;
};
datablock ItemData(bearTrapItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = Swol_TrapSet.path @ "/model/beartrap_item.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Bear Trap";
	iconName = Swol_TrapSet.path @ "/model/icon_beartrap";
	doColorShift = false;

	image = bearTrapImage;
	canDrop = true;
};
datablock ShapeBaseImageData(bearTrapImage)
{
	isTrap = true;
	trapDb = Trap_BearTrap;
	singleUse = true;
	shapeFile 			= bearTrapItem.shapeFile;
	emap 				= true;

	mountPoint 			= 0;
	offset 				= "-0.525 0.05 0.02";
	eyeOffset 			= "0 1.1 -0.8";
	rotation 			= "0 1 0 0";
	
	armReady = false;
};
datablock AudioProfile(bearTrapSnapEmptySound)
{
	filename    = Swol_TrapSet.path @ "/sound/beartrap_snapEmpty.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(bearTrapSnapPersonSound)
{
	filename    = Swol_TrapSet.path @ "/sound/beartrap_snapPerson.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(bearTrapExplode1Sound)
{
	filename    = Swol_TrapSet.path @ "/sound/beartrap_explode1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(bearTrapExplode2Sound)
{
	filename    = Swol_TrapSet.path @ "/sound/beartrap_explode2.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(bearTrapCreateSound)
{
	filename    = Swol_TrapSet.path @ "/sound/beartrap_create.wav";
	description = AudioDefault3d;
	preload = true;
};
function bearTrapImage::onMount(%db,%pl,%slot)
{
	%pl.playThread(1,armReadyBoth);
	%pl.swol_trapPlaceStart(%db.trapDb);
}
function bearTrapImage::onUnMount(%db,%pl,%slot)
{
	%pl.swol_trapPlaceStop();
}
function Trap_BearTrapTrigger::onTickTrigger(%this,%trig,%pl)
{
	Trap_BearTrapTrigger.onEnterTrigger(%trig,%pl);
}
function Trap_BearTrapTrigger::onEnterTrigger(%this,%trig,%pl)
{
	if(!isObject(%trap = %trig.trap))
		return;
	if(!%trap.activated)
	{
		%z = getWord(%trig.getPosition(),2);
		%pz = getWord(%pl.getPosition(),2);
		if(%pz > %z)
			%trap.set.call("trapTrigger_BearTrap",%trap,%pl);
	}
}
function Swol_TrapSet::trapCreate_BearTrap(%set,%trans,%db)
{
	%trap = %set.call(%set.defaultFunc["Create"],%trans,%db);
	%p = new Projectile()
	{
		datablock = %db.placeExplosion;
		initialPosition = %trap.getPosition();
		scale = "1 1 1";
	};
	%trap.activated2 = 0;
	%p.explode();
	serverPlay3D(bearTrapCreateSound,%trans);
	return %trap;
}
function Swol_TrapSet::trapTrigger_BearTrap(%set,%trap,%victim)
{
	if((%res = swol_trapMinigameValid(%owner = %trap.owner,%victim)) != 1)
	{
		if(%res == -1)
		{
			if(%victim.getClassName() $= "AiPlayer" && isObject(%brick = %victim.spawnBrick) && %brick.client == %owner)
				%pass = true;
			else if(%owner == %victim.client)
				%pass = true;
			if(!%pass)
				return;
		}
		if(%res == 0)
			return;
	}
	%set.call(%set.defaultFunc["trigger"],%trap,%victim);
	if(%victim !$= "")
	serverPlay3d(bearTrapSnapPersonSound,%trap.getPosition());
	%db = %trap.getDatablock();
	if(isObject(%victim))
	{
		%trap.caught = %victim;
		%victim.damage((isObject(%trap.owner) ? %trap.owner : %victim),%victim.getPosition(),%db.trapDmg,$DamageType::BearTrap);
		if(%victim.getDamagePercent() < 1)
		{
			%victim.cameraTriggerDisabled = 1;
			if(fileBase(%victim.getDatablock().shapeFile) $= "m")
			{
				if(%victim.getDatablock().getName() !$= PlayerFrozen || !isObject(%victim.tmpBearTrapDb))
					%victim.tmpBearTrapDb = %victim.getDatablock();
				%victim.setDatablock(PlayerFrozen);
			}
			else
			{
				if(isObject(%cl = %victim.client))
				{
					if(isObject(%cam = %cl.camera))
					{
						%cam.setMode("Corpse",%victim);
						%cl.setControlObject(%cam);
						%cam.setTransform(%pl.getEyeTransform());
					}
				}
				else
				{
					%victim.tmpAiHack = new aiPlayer()
					{
						datablock = playerStandardArmor;
						position = "0 0 -999999";
					};
					%victim.setControlObject(%victim.tmpAiHack);
				}
				%victim.bearTrapGimpMoveSpeed = 1;
				%victim.swolSupp_SaveMoveSpeed();
				%victim.swolSupp_NullMoveSpeed();
			}
		}
		%victim.swolSupp_pullToLocation(vectorAdd(%trap.getPosition(),vectorScale(%db.offset,-1)),8,0,20);
	}
	if(!$Swol_BearTrapsReset)
	{
		%trap.breakSched = %set.schedule(%db.holdTime,trapBreak_BearTrap,%trap,%victim);
	}
	else
	{
		%trap.breakSched = %set.schedule(%db.holdTime,trapReset_BearTrap,%trap,%victim);
	}
}
function Swol_TrapSet::trapProjBreak_BearTrap(%set,%trap,%victim)
{
	if(!%trap.activated2)
	{
		serverPlay3d(bearTrapSnapEmptySound,%trap.getPosition());
		%set.call(%set.defaultFunc["trigger"],%trap,%victim);
		%trap.breakSched = %set.schedule(800,trapBreak_BearTrap,%trap,%victim);
	}
}
function Swol_TrapSet::trapReset_BearTrap(%set,%trap)
{
	%trap.playThread(1,reset);
	%trap.activated2 = false;
	%trap.activated = false;
}
function Swol_TrapSet::trapBreak_BearTrap(%set,%trap,%victim)
{
	if(!isObject(%trap))
		return;
	%db = %trap.getDatablock();
	if(!isObject(%victim))
	{
		if(isObject(%trap.caught))
		{
			%victim = %trap.caught;
		}
	}
	serverPlay3D(bearTrapExplode @ getRandom(1,2) @ Sound,%trap.getPosition());
	%set.call(%set.defaultFunc["Break"],%trap);
	if(isObject(%victim))
	{
		if(%victim.cameraTriggerDisabled)
			if(isObject(%cl = %victim.client))
				if(isObject(%cl.camera))
					if(%cl.camera.getControllingClient() == %cl)
						%cl.setControlObject(%victim);
		if(%victim.bearTrapGimpMoveSpeed)
		{
			%victim.swolSupp_ResetMoveSpeed();
			%victim.bearTrapGimpMoveSpeed = "";
		}
		if(isObject(%victim.tmpAiHack))
		{
			%victim.setControlObject(%victim);
			%victim.tmpAiHack.delete();
		}
		if(!isObject(%db = %victim.tmpBearTrapDb) || %victim.getDamagePercent() >= 1)
			return;
		%victim.setDatablock(%db);
	}	
}