ForceRequiredAddon("Vehicle_Tank");
if(!isObject(bearTrapFragDebris))
{
	datablock DebrisData(bearTrapFragDebris)
	{
		shapeFile 			= Swol_TrapSet.path @ "model/debris_frag.dts";
		lifetime 			= 2.8;
		spinSpeed			= 1200.0;
		minSpinSpeed 		= -3600.0;
		maxSpinSpeed 		= 3600.0;
		elasticity 			= 0.5;
		friction 			= 0.2;
		numBounces 			= 3;
		staticOnMaxBounce 	= true;
		snapOnMaxBounce 	= false;
		fade 				= true;
		gravModifier 		= 4;
	};
}
if(!isObject(bearTrapExplosionParticle))
{
	datablock ParticleData(bearTrapExplosionParticle)
	{
		dragCoefficient      = 1;
		gravityCoefficient   = 0.4;
		inheritedVelFactor   = 0.2;
		constantAcceleration = 0.0;
		lifetimeMS           = 500;
		lifetimeVarianceMS   = 100;
		textureName          = "base/data/particles/cloud";
		spinSpeed			= 10.0;
		spinRandomMin		= -50.0;
		spinRandomMax		= 50.0;
		colors[0]			= "0.6 0.6 0.6 0.3";
		colors[1]			= "0.6 0.6 0.6 0.0";
		sizes[0]			= 1.25;
		sizes[1]			= 2.25;
		useInvAlpha 		= true;
	};
}
if(!isObject(bearTrapExplosionEmitter))
{
	datablock ParticleEmitterData(bearTrapExplosionEmitter)
	{
		ejectionPeriodMS	= 1;
		periodVarianceMS	= 0;
		ejectionVelocity	= 4;
		velocityVariance	= 1.0;
		ejectionOffset  	= 0.0;
		thetaMin			= 89;
		thetaMax			= 90;
		phiReferenceVel		= 0;
		phiVariance			= 360;
		overrideAdvance		= false;
		particles			= bearTrapExplosionParticle;
	};
}
AddDamageType("LandMine",'%1 blew themselves to bits','%2 blew %1 to bits',0.2,1);
datablock StaticShapeData(Trap_LandMine)
{
	shapeFile = Swol_TrapSet.path @ "/model/landmine.dts";
	offset = "0 0 0";
	ghost = Trap_LandMineGhost;
	scale = "1 1 1";
	triggerAnim = "";
	triggerExplosion = "";
	placeExplosion = landMinePlaceExplosionProjectile;
	breakExplosion = tankShellProjectile;
	rootAnim = "";
	triggerDb = Trap_LandMineTrigger;
	triggerScale = "8 8 8";
	triggerSphere = 1;
	checkScale = "0.8 0.8 0.2";
	triggerWithProjectiles = true;
	trapDmg = 35;
	trapHp = 20;
	explodeDelay = 1200;
	armDelay = 800;
	cooldown = 15000;
	camo = 0;
	
	useCmd["Create"] = "trapCreate_LandMine";
	useCmd["Remove"] = "trapRemove_LandMine";
	useCmd["Break"] = "";
	useCmd["ProjBreak"] = "";
	useCmd["ExpBreak"] = "";
	useCmd["Trigger"] = "";
	
	trapName = "LandMine";
	uiName = "Land Mine";
};
datablock StaticShapeData(Trap_LandMineGhost)
{
	shapeFile = Swol_TrapSet.path @ "/model/landmine_ghost.dts";
};
datablock TriggerData(Trap_LandMineTrigger)
{
   tickPeriodMS = 50;
   isSphere = 1;
};
datablock ParticleData(landMineFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	textureName          = "base/lighting/corona";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "1 0.1 0.1 1";
	colors[1]     = "1 0.1 0.1 0.6";
	colors[2]     = "1 0.1 0.1 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 2.2;
	sizes[2]      = 0;
	times[0]      = 0;
	times[1]      = 1;
	times[2]      = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(landMineFlashEmitter)
{
	ejectionPeriodMS = 500;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = landMineFlashParticle;

	emitterNode = GenericEmitterNode;
	pointEmitterNode = TenthEmitterNode;

	useEmitterColors = 0;
};
datablock ExplosionData(landMinePlaceExplosion)
{
	debris 					= bearTrapFragDebris;
	debrisNum 				= 5;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 12;
	debrisVelocityVariance 	= 6;
	particleEmitter 		= bearTrapExplosionEmitter;
	particleDensity 		= 5;
	particleRadius 			= 0.2;
	lifeTimeMS 				= 150;
	faceViewer     			= true;
	explosionScale 			= "1 1 1";
	shakeCamera 			= true;
	camShakeFreq 			= "5.0 6.0 5.0";
	camShakeAmp 			= "1.0 2.0 1.0";
	camShakeDuration 		= 0.3;
	camShakeRadius 			= 20.0;
};
datablock ProjectileData(landMinePlaceExplosionProjectile)
{
	explosion = landMinePlaceExplosion;
};
datablock AudioProfile(landMineCreateSound)
{
	filename    = Swol_TrapSet.path @ "/sound/landmine_create.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(landMineActivateSound)
{
	filename    = Swol_TrapSet.path @ "/sound/landmine_activate.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(landMineAlertSound)
{
	filename    = Swol_TrapSet.path @ "/sound/landmine_alert.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock ItemData(landMineItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = Swol_TrapSet.path @ "/model/landmine_item.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Landmine";
	iconName = Swol_TrapSet.path @ "/model/icon_landmine";
	doColorShift = false;

	image = landMineImage;
	canDrop = true;
};
datablock ShapeBaseImageData(landMineImage)
{
	isTrap = true;
	trapDb = Trap_LandMine;
	singleUse = true;
	shapeFile 			= Swol_TrapSet.path @ "/model/landmine_item.dts";
	emap 				= true;

	mountPoint 			= 0;
	offset 				= "0.05 0.4 0";
	eyeOffset 			= "0 0 0";
	eyeRotation			= "0 1 0 0";
	rotation 			= "0 1 0 90";
	
	armReady = true;
};
function landMineImage::onMount(%db,%pl,%slot)
{
	%pl.swol_trapPlaceStart(%db.trapDb);
}
function landMineImage::onUnMount(%db,%pl,%slot)
{
	%pl.swol_trapPlaceStop();
}
function Trap_LandMineTrigger::onLeaveTrigger(%db,%trig,%pl)
{
	if(!isObject(%trap = %trig.trap))
		return;
}
function Trap_LandMineTrigger::onEnterTrigger(%db,%trig,%pl)
{
	if(!isObject(%trap = %trig.trap))
		return;
	if(!%trap.isActive)
		return;
	if(isObject(%cl = %pl.client))
	{
		if(%cl == %trap.owner)
			return;
	}
	if(%trap.getDatablock().triggerSphere)
		if(vectorDist(%pl.getPosition(),%trig.getPosition()) > vectorGetMin(%trig.getScale()))
			return;
	if(!%trap.activated)
	{
		%trap.set.call("trapTrigger_LandMine",%trap,%pl);
	}
}
function Swol_TrapSet::trapCreate_LandMine(%set,%trap,%trans)
{
	%trap = %set.call(%set.defaultFunc["Create"],%trap,%trans);
	serverPlay3D(landMineCreateSound,%trap.getPosition());
	%trap.isActive = false;
	%p = new Projectile()
	{
		datablock = %trap.getDatablock().placeExplosion;
		initialPosition = %trap.getPosition();
		scale = "0.5 0.5 0.5";
	};
	%p.explode();
	%set.schedule(%trap.getDatablock().armDelay,trapActivate_LandMine,%trap);
	return %trap;
}
function Swol_TrapSet::trapActivate_LandMine(%set,%trap)
{
	if(!isObject(%trap))
		return;
	%trap.isActive = true;
	%trap.emitterEffect = swol_createEmitter(landMineFlashEmitter,%trap.getPosition());
	%pos = %trap.getPosition();
	if(%trap.getDatablock().camo)
	{
		%r = containerRayCast(vectorAdd(%pos,"0 0 0.4"),vectorAdd(%pos,"0 0 -0.2"),($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType),%trap);
		if(isObject(%r))
		{
			if(%r.getClassName() $= "fxPlane")
			{
				%col = %r.color;
				%r = getWord(%col,0)/255;
				%g = getWord(%col,1)/255;
				%b = getWord(%col,2)/255;
				//%a = getWord(%col,3)/255;
				%col = %r SPC %g SPC %b SPC 1;
			}
			else if(%r.getClassName() $= "fxDtsBrick")
			{
				%colid = %r.getColorId();
				%col = getColorIDTable(%colid);
			}
			else if(%r.getClassName() $= "StaticShape")
			{
				if(%r.color !$= "")
					%col = %r.color;
				else if(%r.col !$= "")
					%col = %r.col;
				else
					%col = "0.4 0.4 0.4 1";
			}
			%trap.setNodeColor("ALL",%col);
		}
	}
	serverPlay3D(landMineActivateSound,%trap.getPosition());
}
function Swol_TrapSet::trapTrigger_LandMine(%set,%trap,%victim)
{
	if(!isObject(%trap))
		return;
	if(!swol_trapMinigameValid(%trap.owner,%victim))
		return;
	%trap.activated = true;
	serverPlay3D(landMineAlertSound,%trap.getPosition());
	%db = %trap.getDatablock();
	%trap.breakSched = %set.schedule(%db.explodeDelay,call,%set.defaultFunc["Dmg"],%trap,999999,"Break");
}
function Swol_TrapSet::trapBreak_LandMine(%set,%trap,%victim)
{
	
}
function Swol_TrapSet::trapRemove_LandMine(%set,%trap)
{
	if(isObject(%trap.emitterEffect))
		%trap.emitterEffect.delete();
	%set.call(%set.defaultFunc["Remove"],%trap);
}
function Swol_TrapSet::trapEffect_LandMine(%set,%trap)
{
	
}
function swol_createEmitter(%db,%pos,%scale)
{
	if(%scale $= "")
		%scale = "0.05 0.05 0.05";
	%b = new ParticleEmitterNode() 
	{
		position = %pos;
		rotation = "1 0 0 0";
		scale = %scale;
		dataBlock = "GenericEmitterNode";
		emitter = %db;
		velocity = "0";
		pointPlacement = "0";
		spherePlacement = "0";
	};
	return %b;
}
//exec("config/5/swol/loadAll.cs");exec("config/5/traps/server.cs");exec("config/5/traps/traps/landmine.cs");exec("config/5/traps/traps/beartrap.cs");fpbn(swol).mountImage(landMineImage,0);